
# Copyright (C) Johan Ceuppens 2010
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 2 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.


import pygame
from pygame.locals import *
from maproom import *
from tree import *
from tree2 import *
from dungeonentrance1 import *
from maproomdungeon import *
from dungeonkey1 import *
from dungeonmasterkey import *
from maproomdungeonnorthwall import *
from goblin1 import *
from goblin2 import *
from goblin3 import *
from tilebox import *
from rope import *
#from snake1 import *
from rubysword import *
from beholder import *
from beholderbat import *
from abeille import *
from abeille2 import *
from bullfrog import *
from scorpionred1 import *
from scorpionred2 import *
from scorpionred3 import *
from skeleton1 import *
from fishman1 import *
from fishman2 import *
from roadsign import *
from movingplatform import *
from chest1 import *
from longbow1 import *

class Maproom2_1(MaproomDungeon):
    "Room with a (big) map"
    def __init__(self,x,y):
        MaproomDungeon.__init__(self,x,y)
        self.background = pygame.image.load("./pics/bg3-4000x4000.bmp").convert()
        ###self.northwall1 = Tilebox(1,1,60,48,16,1,'./pics/walldungeonnorth2-beholderglass-60x48.bmp')
##        self.northwall1 = Tilebox(1,1,60,48,13,1,'./pics/walldungeonnorth1-60x48.bmp')
##        self.southwall1 = Tilebox(1,200,30,48,13,1,'./pics/walldungeonsouth1-30x48.bmp')
##        self.westwall1 = Tilebox(360,200,48,60,1,10,'./pics/walldungeonwest1-48x60.bmp')
##        self.eastwall1 = Tilebox(775,1,48,60,1,14,'./pics/walldungeoneast1-48x60.bmp')
##        self.tileboxes.append(self.northwall1)
##        self.tileboxes.append(self.westwall1)
##        self.tileboxes.append(self.eastwall1)
##        self.tileboxes.append(self.southwall1)

        

        # left NOTE!!! : boxes collide so put them after enemies and roadsigns !
        self.gameobjects.append(Skeleton1(700,280))
        self.gameobjects.append(Skeleton1(1000,280))
        self.gameobjects.append(ScorpionRed2(2500,720))
        self.gameobjects.append(ScorpionRed2(2400,720))
        self.gameobjects.append(ScorpionRed3(500,300))
        self.gameobjects.append(ScorpionRed3(400,300))
        self.gameobjects.append(Fishman2(2000,1400))
        self.gameobjects.append(Fishman2(2100,1500))
        self.gameobjects.append(Fishman2(2200,1400))
        self.gameobjects.append(Fishman2(2300,1400))
        self.gameobjects.append(Fishman2(2400,1500))
##        self.gameobjects.append(Fishman2(2500,1400))
##        self.gameobjects.append(Fishman2(2600,1550))
##        self.gameobjects.append(Fishman2(2700,1400))

        self.gameobjects.append(Fishman2(3000,1400))
        self.gameobjects.append(Fishman2(3100,1500))
        self.gameobjects.append(Fishman2(3200,1400))
        self.gameobjects.append(Fishman2(3300,1500))
        
        # NOTE !! set items after because they collid ewit hfighting
        self.gameobjects.append(Chest1(50,500))
        self.gameobjects.append(Dungeonkey1(3000,80))
        self.gameobjects.append(Longbow1(1900,870)) 
        
##
##        # FIXME1 do not collide with other fishman for boxes
##        self.gameobjects.append(Fishman1(100,600))
##        self.gameobjects.append(Fishman1(300,800))
##        self.gameobjects.append(Fishman1(500,400))
##        self.gameobjects.append(Fishman1(700,500))
##                
##        # left NOTE!!! : boxes collide so put them after enemies !
        ####### upper 
        self.gameobjects.append(Box(0,375,750+715,12))
        self.gameobjects.append(Box(750+785,375,365,12))
        self.gameobjects.append(Box(750+1000,375,450,12))
        self.gameobjects.append(Box(2250,375,1700,12))
        # upperest platform
        self.gameobjects.append(Box(2790,170,400,12))
        # upper left room wall
        self.gameobjects.append(Box(750+1000,0,12,375))
        # roof
        self.gameobjects.append(Box(0,0,12,2200))
        # ropes
        self.ropes.append(Rope(2780,90,200))
        self.ropes.append(Rope(750+720,0,720))
        ####### upper 2
        self.gameobjects.append(Box(0,600,200,12))
        self.gameobjects.append(Box(750+0,600,715,12))
        self.gameobjects.append(Box(750+785+50,600,590,12))
        self.gameobjects.append(Box(750+785+50+590+50,600,1775,12))
        # ropes
        self.ropes.append(Rope(2210,200,520))
        ####### upper 3
        self.gameobjects.append(Box(0,800,2150,12))
        self.gameobjects.append(Box(2300,800,1075,12))
        # ropes
        self.ropes.append(Rope(3400,720,520))
        ####### upper 4
        self.gameobjects.append(Box(1750,955,350,24))
        self.gameobjects.append(Box(2050,1005,1325,12))
        # wall (corner)
        self.gameobjects.append(Box(1750,800,50,200))

        ####### upper 5
        self.gameobjects.append(Box(1100,1150,1440,12))
        ####### upper 5 wall + corner + rope
        self.gameobjects.append(Box(900,800,24,200))
        self.gameobjects.append(Box(900,1050,300,12))
        self.ropes.append(Rope(1150,900,260))
        ####### upper 6
        self.gameobjects.append(Box(2550,1400,1350,12))
        # ropes
        self.ropes.append(Rope(2560,1050,320))
        # floor under rope
        # moving platforms
        self.movingplatforms.append(Movingplatform(200,550,100,42,200,670))        

    def draw(self,screen,player):
        # draw bg
        screen.blit(self.background, (0+self.relativex, 0+self.relativey))
        # draw walls
        MaproomDungeon.draw(self,screen)
        for t in self.tileboxes:
            t.draw(screen,self.relativex,self.relativey)
        #self.southwall1.draw(screen,self.relativex,self.relativey)
        # draw gameobjects
        for i in self.gameobjects:
	    if i != None:
		i.update(self,player)
		i.draw(screen,self)
	for i in self.ropes:
	    if i != None:
		i.update(self,player)
		i.draw(screen,self)
	for i in self.movingplatforms:
            if i != None:
                i.update(self,player)
                i.draw(screen,self,player)
                
    def isroomdoorexitleft(self):
	if self.relativex  > 180-750 and self.relativex < 250-750 and self.relativey >= -20:
		return 1
	return 0

    def setxyfromdoorleft(self,game):
        game.x = -400
	game.y = 0

    def isroomdoorexit(self):
	if self.relativex  < -720 and self.relativex > - 820 and self.relativey < -590 and self.relativey > -690:
		return 1
	return 0

    def setxyfromdoor(self,game):
        game.x = 0
        game.y = 0

    def exit(self, game):
	if self.isroomdoorexitleft():
		self.setxyfromdoorleft(game)
		return 2
	if self.isroomdoorexit():
		self.setxyfromdoor(game)
		return 2.2
	return 0 
 
    def collidesword(self,player):
        for i in self.gameobjects:
	    if i!= None:
	    	id = i.collidewithsword(self,player)
		#self.relativex = self.prevx
		#self.relativey = self.prevy
		return i ## NOTE : returns collided entity (single)
	return None


    def removeobject(self, o):
        for i in range(0,len(self.gameobjects)):
            if self.gameobjects[i] == o:
                self.gameobjects[i] = None

    def talkto(self):#FIXME needs font
        return None
##          print "talk to in maproom 2_1"
##            ## return self.koboldwiz
##            self.roadsign.talkcounter = 1
##            return self.roadsign
